Package: hmm.discnp
Version: 3.0-9
Date: 2022-09-26
Title: Hidden Markov Models with Discrete Non-Parametric Observation
        Distributions
Author: Rolf Turner
Maintainer: Rolf Turner <r.turner@auckland.ac.nz>
Depends: R (>= 2.10)
Imports: nnet (>= 7.3.12)
Description: Fits hidden Markov models with discrete non-parametric 
	observation distributions to data sets.  The observations may
	be univariate or bivariate. Simulates data from such models.
	Finds most probable underlying hidden states, the most
	probable sequences of such states, and the log likelihood
	of a collection of observations given the parameters of
	the model.  Auxiliary predictors are accommodated in the
        univariate setting.
LazyData: true
ByteCompile: true
License: GPL (>= 2)
NeedsCompilation: yes
Packaged: 2022-09-26 08:27:50 UTC; rolf
Repository: CRAN
Date/Publication: 2022-09-26 09:10:06 UTC
Built: R 4.4.0; x86_64-apple-darwin20.6.0; 2024-04-30 04:17:24 UTC; unix

# Export everything
exportPattern("*")
S3method(fitted,hmm.discnp)
S3method(anova,hmm.discnp)
S3method(predict,hmm.discnp)
S3method(rhmm,hmm.discnp)
S3method(update,hmm.discnp)
S3method(rhmm,default)
S3method("[","multipleHmmDataSets")
importFrom("stats", "runif")
importFrom("stats", "rbinom")
importFrom("stats", "xtabs")
importFrom("stats", "pchisq")
importFrom("stats", "optim")
importFrom("stats", "coef")
importFrom("stats", "rnorm")
importFrom("nnet",multinom)
importFrom("stats", "nlm")
importFrom("stats", "update")
importFrom("stats", "var")
importFrom("stats", "quantile")
importFrom("stats", "optimize")
useDynLib(hmm.discnp)

subroutine getgl(fy,y,ymiss,tpm,xispd,d1pi,kstate,n,
                 npar,d1p,m,d1f,alpha,alphw,a,aw,xlc)
implicit double precision(a-h,o-z)

integer   y(n)
integer   ymiss(n)
dimension fy(kstate,n)
dimension tpm(kstate,kstate), xispd(kstate)
dimension d1pi(kstate,npar), d1p(kstate,kstate,npar)
dimension d1f(m,kstate,npar), alpha(kstate), alphw(kstate)
dimension a(kstate,npar), aw(kstate,npar), xlc(n)

# Set zero.
zero = 0.d0

# Initialize; i.e. do the t = 1 case:
sxlc = zero
do j = 1,kstate {
	alpha(j) = xispd(j)*fy(j,1)
	sxlc = sxlc + alpha(j)
	do k = 1,npar {
                if(ymiss(1) == 1) {
                    d1fx = zero
                } else {
                    d1fx = d1f(y(1),j,k)
                }
		a(j,k) = xispd(j)*d1fx + fy(j,1)*d1pi(j,k)
	}
}
xlc(1) = sxlc

do j = 1,kstate {
	alpha(j) = alpha(j)/sxlc
}

if(n>1) {
do kt = 2,n {
	kstart = 1+(kt-1)*kstate
# Do the a's:
	do j = 1,kstate {
		do k = 1,npar {
                    if(ymiss(kt) == 1) {
                        d1fx = zero
                    } else {
                        d1fx = d1f(y(kt),j,k)
                    }
			xxx = zero
			yyy = zero
			zzz = zero
			do i = 1, kstate {
				xxx = xxx + alpha(i)*d1p(i,j,k)
				yyy = yyy + a(i,k)*tpm(i,j)
				zzz = zzz + alpha(i)*tpm(i,j)
			}
			aw(j,k) = fy(j,kt)*(xxx + yyy/sxlc) + d1fx*zzz
		}
	}
	do j = 1,kstate {
		do k = 1,npar {
			a(j,k) = aw(j,k)
		}
	}

# Do the alpha's:
	sxlc = zero
	do j = 1,kstate {
		alphw(j) = zero
		do i = 1,kstate {
			alphw(j) = alphw(j) + alpha(i)*tpm(i,j)
		}
		alphw(j) = fy(j,kt)*alphw(j)
		sxlc = sxlc + alphw(j)
	}
	xlc(kt) = sxlc
	do j = 1,kstate {
		alpha(j) = alphw(j)/sxlc
	}
}
}

return
end

subroutine getl(fy,tpm,xispd,kstate,n,alpha,alphw,xlc)
implicit double precision(a-h,o-z)

dimension fy(kstate,n)
dimension tpm(kstate,kstate), xispd(kstate)
dimension alpha(kstate), alphw(kstate)
dimension xlc(n)

# Set zero.
zero = 0.d0

# Initialize; i.e. do the t = 1 case:
sxlc = zero
do j = 1,kstate {
	alpha(j) = xispd(j)*fy(j,1)
	sxlc = sxlc + alpha(j)
}
xlc(1) = sxlc

do j = 1,kstate {
	alpha(j) = alpha(j)/sxlc
}

if(n>1) {
do kt = 2,n {
	sxlc = zero
	do j = 1,kstate {
		alphw(j) = zero
		do i = 1,kstate {
			alphw(j) = alphw(j) + alpha(i)*tpm(i,j)
		}
		alphw(j) = fy(j,kt)*alphw(j)
		sxlc = sxlc + alphw(j)
	}
	xlc(kt) = sxlc
	do j = 1,kstate {
		alpha(j) = alphw(j)/sxlc
	}
}
}

return
end

subroutine bfun(fy,tpm,epsilon,n,nstate,wrk,beta)
implicit double precision(a-h,o-z)
dimension wrk(nstate)
dimension fy(nstate,n), tpm(nstate,nstate), beta(nstate,n)

# Set some constants.
one  = 1.d0
zero = 0.d0

# Set the last beta's.

do j = 1,nstate {
	beta(j,n) = one # Doesn't matter that the beta_n's are
}                       # not rescaled.

# Run through the remaining n-1 of the betas (recursing!), backwards.
do ktb = 2,n {
	kt  = n - ktb + 1
	ktp = kt + 1
	tsum = zero
	do i = 1,nstate {
		wrk(i) = zero
		do j = 1,nstate {
			wrk(i) = wrk(i) + tpm(i,j)*beta(j,ktp)*fy(j,ktp)
		}
		tsum = tsum + wrk(i)
	}
	if(tsum < epsilon) {
		do j = 1,nstate {
			beta(j,kt) = one/nstate
		}
	}
	else {
		do j = 1,nstate {
			beta(j,kt) = wrk(j)/tsum
		}
	}
}

return
end

subroutine afun(fy,xispd,tpm,epsilon,n,nstate,wrk,xlc,alpha,nr)
implicit double precision(a-h,o-z)
dimension wrk(nstate), xispd(nstate), xlc(n)
dimension fy(nstate,n), tpm(nstate,nstate), alpha(nstate,n)

# Set some constants
one  = 1.d0
zero = 0.d0

# Set the value to give to ``log-likelihood constant'', xlc(...)
# if this is indeterminate --- i.e. less than epsilon.
# Possible choices: -1, 1, or epsilon.
dummy = epsilon

# Update the initial alpha.
tsum = zero
do j = 1,nstate {
	wrk(j) =  fy(j,1)*xispd(j)
	tsum = tsum + wrk(j)
#if(nr == 1) {
#    call dblepr("wrk(j):",-1,wrk(j),1)
#    call dblepr("tsum:",-1,tsum,1)
#}
}

if(tsum < epsilon) {
	xlc(1) = dummy
	do j = 1,nstate {
		alpha(j,1) = one/nstate
	}
}
else {
	xlc(1) = tsum
	do j = 1,nstate {
		alpha(j,1) = wrk(j)/tsum
	}
}
kt = 1
#call intpr("Old code; kt =",-1,kt,1)
#call dblepr("Old code; xlc(kt)=",-1,xlc(kt),1)

# Run through the remaining n-1 of the alphas (recursing!).
do kt = 2,n {
	tsum = zero
	ktm = kt - 1
	do j = 1,nstate {
		wrk(j) = zero
		do i = 1,nstate {
			wrk(j) = wrk(j) + alpha(i,ktm)*tpm(i,j)
		}
		wrk(j) = fy(j,kt)*wrk(j)
		tsum = tsum + wrk(j)
	}
	if(tsum < epsilon) {
		xlc(kt) = dummy
		do j = 1,nstate {
			alpha(j,kt) = one/nstate
		}
	}
	else {
		xlc(kt) = tsum
		do j = 1,nstate {
			alpha(j,kt) = wrk(j)/tsum
		}
	}
#call intpr("Old code; kt =",-1,kt,1)
#call dblepr("Old code; xlc(kt)=",-1,xlc(kt),1)
}

return
end

subroutine gfun(alpha,beta,epsilon,n,nstate,wrk,gamma)
implicit double precision(a-h,o-z)
dimension alpha(nstate,n), beta(nstate,n), gamma(nstate,n)
dimension wrk(nstate)

zero = 0.d0
ook  = 1.d0/dble(nstate)

do kt = 1,n {
	tsum = zero
	do i = 1,nstate {
		wrk(i) = alpha(i,kt)*beta(i,kt)
		tsum = tsum + wrk(i)
	}
	if(tsum<epsilon) {
		do i = 1,nstate {
			gamma(i,kt) = ook
		}
	}
	else {
		do i = 1,nstate {
			gamma(i,kt) = wrk(i)/tsum
		}
	}
}

return
end

subroutine xfun(alpha,beta,fy,tpm,epsilon,n,nstate,nm1,wrk,xi)
implicit double precision(a-h,o-z)
dimension alpha(nstate,n), beta(nstate,n), fy(nstate,n)
dimension tpm(nstate,nstate), wrk(nstate,nstate), xi(nstate,nstate,nm1)

one  = 1.d0
zero = 0.d0
dns2 = dble(nstate*nstate)

do ktp = 2,n {
	kt = ktp - 1
	tsum = zero
	do i = 1,nstate {
		do j = 1, nstate {
			wrk(i,j) = alpha(i,kt)*fy(j,ktp)*beta(j,ktp)*tpm(i,j)
			tsum = tsum + wrk(i,j)
		}
	}
	if(tsum<epsilon) {
		do i = 1,nstate {
			do j = 1,nstate {
				xi(i,j,kt) = one/dns2
			}
		}
	}
	else {
		do i = 1,nstate {
			do j = 1,nstate {
				xi(i,j,kt) = wrk(i,j)/tsum
			}
		}
	}
}

return
end

subroutine recurse(fy,xispd,tpm,nreps,epsilon,lns,nstate,nis,cis,
                   wrk,xlc,ntot,nxi,alpha,beta,gamma,xi,xisum)

implicit double precision(a-h,o-z)
integer cis
dimension xispd(nstate,nis), xlc(ntot), lns(nreps)
dimension tpm(nstate,nstate), wrk(nstate,nstate)
dimension fy(nstate,ntot), alpha(nstate,ntot), beta(nstate,ntot)
dimension gamma(nstate,ntot), xi(nstate,nstate,nxi), xisum(nstate,nstate)

# Set zero and one:
zero = 0.d0
one  = 1.d0

# Run through the replicates.
kstop = 0
do k = 1,nreps {
	n = lns(k)
        nm1 = n - 1
	kstart = 1 + kstop
        if(cis > 0) {
            kis = 1
        } else {
            kis = k
        }

# Update the alpha's.
nr = k
	call afun(fy(1,kstart),xispd(1,kis),tpm,epsilon,n,nstate,wrk,
                  xlc(kstart),alpha(1,kstart),nr)

# Update the beta's.
	call bfun(fy(1,kstart),tpm,epsilon,n,nstate,wrk,
                  beta(1,kstart))

# Update the gamma's.
	call gfun(alpha(1,kstart),beta(1,kstart),epsilon,n,
                  nstate,wrk,gamma(1,kstart))

# Update the xi's.
	call xfun(alpha(1,kstart),beta(1,kstart),fy(1,kstart),
                  tpm,epsilon,n,nstate,nm1,wrk,xi(1,1,kstart-k+1))

# Increment kstop.
kstop = kstop + lns(k)
}

kstop = kstop - nreps
# Sum up the xi's.
do i = 1,nstate {
	do j = 1,nstate {
		xisum(i,j) = zero
		do k = 1,kstop {
			xisum(i,j) = xisum(i,j) + xi(i,j,k)
		}
	}
}

return
end

subroutine gethgl(fy,y,ymiss,tpm,xispd,d1pi,d2pi,kstate,n,
                  npar,d1p,d2p,m,d1f,d2f,alpha,alphw,a,b,aw,bw,
                  xlc,ll,grad,hess)
implicit double precision(a-h,o-z)

double precision ll
integer   y(n)
integer   ymiss(n)
dimension fy(kstate,n)
dimension tpm(kstate,kstate), xispd(kstate)
dimension d1pi(kstate,npar), d2pi(kstate,npar,npar)
dimension d1p(kstate,kstate,npar), d2p(kstate,kstate,npar,npar)
dimension d1f(m,kstate,npar), d2f(m,kstate,npar,npar)
dimension alpha(kstate), alphw(kstate)
dimension a(kstate,npar), b(kstate,npar,npar)
dimension aw(kstate,npar), bw(kstate,npar,npar)
dimension xlc(n), grad(npar), hess(npar,npar)
#

# Set zero.
kt = 1
zero = 0.d0

# Initialize; i.e. do the t = 1 case:
sxlc = zero
do j = 1,kstate {
    alpha(j) = xispd(j)*fy(j,1)
    sxlc = sxlc + alpha(j)
    do k1 = 1,npar {
        if(ymiss(1) == 1) {
            d1fx1 = 0
        } else {
            d1fx1 = d1f(y(1),j,k1)
        }
        a(j,k1) = xispd(j)*d1fx1 + fy(j,1)*d1pi(j,k1)
        do k2 = 1,npar {
            if(ymiss(1) == 1) {
                d1fx2 = 0
            } else {
                d1fx2 = d1f(y(1),j,k2)
            }
            if(ymiss(1) == 1) {
                d2fx = 0
            } else {
                d2fx = d2f(y(1),j,k1,k2)
            }
            b(j,k1,k2) = (xispd(j)*d2fx + d1pi(j,k1)*d1fx2 +
                                          d1pi(j,k2)*d1fx1 +
                                          fy(j,1)*d2pi(j,k1,k2))
        }
    }
}
xlc(1) = sxlc

do j = 1,kstate {
    alpha(j) = alpha(j)/sxlc
}

if(n>1) {
do kt = 2,n {
# Do the b's:
    do j = 1,kstate {
        do k1 = 1,npar {
            if(ymiss(kt) == 1) {
                d1fx1 = 0
            } else {
                d1fx1 = d1f(y(kt),j,k1)
            }
            do k2 = 1,npar {
                if(ymiss(kt) == 1) {
                    d1fx2 = 0
                    d2fx  = 0
                } else {
                    d1fx2 = d1f(y(kt),j,k2)
                    d2fx  = d2f(y(kt),j,k1,k2)
                }
                vvv = zero
                xxx = zero
                yy1 = zero
                yy2 = zero
                zz1 = zero
                zz2 = zero
                www = zero
                do i = 1,kstate {
                    vvv = vvv+alpha(i)*d2p(i,j,k1,k2)
                    xxx = (xxx + a(i,k1)*d1p(i,j,k2) + a(i,k2)*d1p(i,j,k1) +
                                                       b(i,k1,k2)*tpm(i,j))
                    yy1 = yy1 + alpha(i)*d1p(i,j,k2)
                    yy2 = yy2 + a(i,k2)*tpm(i,j)
                    zz1 = zz1 + alpha(i)*d1p(i,j,k1)
                    zz2 = zz2 + a(i,k1)*tpm(i,j)
                    www = www + alpha(i)*tpm(i,j)
                }
                vvv = fy(j,kt)*vvv
                xxx = fy(j,kt)*xxx/sxlc
                yyy = d1fx1*(yy1 + yy2/sxlc)
                zzz = d1fx2*(zz1 + zz2/sxlc)
                www = d2fx*www
                bw(j,k1,k2) = vvv + xxx + yyy + zzz + www
            }
        }
    }

    do j = 1,kstate {
        do k1 = 1,npar {
            do k2 = 1,npar {
                b(j,k1,k2) = bw(j,k1,k2)
            }
        }
    }

# Do the a's:
    do j = 1,kstate {
        do k = 1,npar {
            if(ymiss(kt) == 1) {
                d1fx = 0
            } else {
                d1fx = d1f(y(kt),j,k)
            }
            xxx = zero
            yyy = zero
            zzz = zero
            do i = 1, kstate {
                xxx = xxx + alpha(i)*d1p(i,j,k)
                yyy = yyy + a(i,k)*tpm(i,j)
                zzz = zzz + alpha(i)*tpm(i,j)
            }
            aw(j,k) = fy(j,kt)*(xxx + yyy/sxlc) + d1fx*zzz
        }
    }
    do j = 1,kstate {
        do k = 1,npar {
            a(j,k) = aw(j,k)
        }
    }

# Do the alpha's:
    sxlc = zero
    do j = 1,kstate {
        alphw(j) = zero
        do i = 1,kstate {
            alphw(j) = alphw(j) + alpha(i)*tpm(i,j)
        }
        alphw(j) = fy(j,kt)*alphw(j)
        sxlc = sxlc + alphw(j)
    }
    xlc(kt) = sxlc
    do j = 1,kstate {
        alpha(j) = alphw(j)/sxlc
    }
}
}

# Finish off:

# Log likelihood.
ll = zero
do kt = 1,n {
   ll = ll + log(xlc(kt))
}

# Gradient.
do j = 1,npar {
   xxx = zero
   do i = 1,kstate {
       xxx = xxx + a(i,j)
   }
   grad(j) = xxx/sxlc
}

# Hessian.
do j1 = 1,npar {
    do j2 = 1,npar {
        xxx = zero
        yyy = zero
        zzz = zero
        do i = 1,kstate {
            xxx = xxx + b(i,j1,j2)
        }
        hess(j1,j2) = xxx/sxlc - grad(j1)*grad(j2)
    }
}

return
end
